/* Materiaux et lumieres                        */
/*                                              */
/* Auteur: Nicolas JANEY                        */
/* nicolas.janey@univ-fcomte.fr                 */
/* Fevrier 2023                                 */

#include <stdlib.h>
#include <stdio.h>

#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "ObjetsGeometriques.h"

/* Variables globales                           */

static float rx = 0.0F;            // Angle de rotation de la scene sur elle-meme autour de l'axe x
static float sens = 1.0F;          // Sens de rotation de la scene sur elle-meme autour de l'axe x
static float ry = 0.0F;            // Angle de rotation de la scene sur elle-meme autour de l'axe y
static float rz = 0.0F;            // Angle de rotation de la scene sur elle-meme autour de l'axe z
static int anim = 0;               // Flag d'activation/desactivation de l'animation
static int mouseActive = 0;        // Flag de d'indication que la souris est active (bouton presse) ou non 
static int mouseX = 0;             // Derniere position en x relevee pour la souris

static int wTx = 360;              // Resolution horizontale de la fenetre
static int wTy = 360;              // Resolution verticale de la fenetre
static int wPx = 50;               // Position horizontale de la fenetre
static int wPy = 50;               // Position verticale de la fenetre

static int polygonMode = 1;        // Flag de switch entre modes d'affichage wireframe et fill 
static int scn = 3;                // Flag de switch entre les 4 scenes
static int normalize = 1;          // Flag de switch avec et sans normalisation
static int n = 50;                 // Niveau de facettisation
static int fond = 1;               // Flag de switch entre couleurs de fond noir et gris clair
static int culling = 0;            // Flag de switch entre affichages avec et sans culling

/* Fonction d'initialisation des parametres     */
/* OpenGL ne changeant pas au cours de la vie   */
/* du programme                                 */

static void init(void) {
  glDepthFunc(GL_LESS);
  glEnable(GL_DEPTH_TEST);
}

void bitmapOutput(float x,float y,float z,char *string,void *font) {
  int len,i;
  glRasterPos3f(x,y,z);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) {
    glutBitmapCharacter(font,string[i]); }
}

//////////////////////////////////////////////////

/* Scene dessinee                               */

static void scene0(void) {
  glPushMatrix();
  glColor3f(0.8F,0.8F,0.0F);
  mySolidSphere(0.8,n,n);
  glTranslatef(0.4F,0.4F,0.4F);
  glColor3f(0.0F,0.8F,0.8F);
  mySolidSphere(0.4,n,n);
  glPopMatrix();
}

static void scene1(void) {
  glPushMatrix();
  glColor3f(0.8F,0.0F,0.8F);
  mySolidCube(1.0,n);
  glTranslatef(0.4F,0.4F,0.4F);
  glColor3f(0.8F,0.8F,0.8F);
  mySolidCube(0.6,n);
  glPopMatrix();
}

static void scene2(void) {
  glPushMatrix();
  glColor3f(0.0F,0.8F,0.0F);
  mySolidCylindre(1.2,0.6,n*3,n,1);
  glTranslatef(0.6F,0.4F,0.4F);
  glColor3f(0.8F,0.0F,0.0F);
  mySolidCylindre(0.6,0.3,n*3,n,1);
  glPopMatrix();
}

static void element(void) {
  glPushMatrix();
  mySolidCylindre(0.9,0.2,n,n*2);
  glPushMatrix();
  glTranslatef(0.75F,-0.75F,0.0F);
  glRotatef(90.0F,0.0F,0.0F,1.0F);
  mySolidCylindre(0.9,0.2,n,n*2);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(0.75F,0.75F,0.0F);
  glRotatef(90.0F,0.0F,0.0F,1.0F);
  mySolidCylindre(0.9,0.2,n,n*2);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(0.0F,-0.75F,0.0F);
  mySolidCube(0.6,n);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(0.0F,0.75F,0.0F);
  mySolidCube(0.6,n);
  glPopMatrix();
  glPopMatrix();
}

static void scene3(void) {
  glPushMatrix();
  glColor3f(1.0F,1.0F,1.0F);
  mySolidSphere(0.5,n,n);
  for ( int i = 0 ; i < 4 ; i++ ) {
    glPushMatrix();
    glRotatef(i*90.0F,0.0F,1.0F,0.0F);
    glTranslatef(-0.75F,0.0,0.75F);
    element();
    glPopMatrix(); }
  glPopMatrix();
}

//////////////////////////////////////////////////

static int informationScene0(typeInfo info) {
  return informationSolidSphere(0.8,n,n,info)+
         informationSolidSphere(0.4,n,n,info);
}

static int informationScene1(typeInfo info) {
  return informationSolidCube(1.0,n,info)+
         informationSolidCube(0.6,n,info);
}

static int informationScene2(typeInfo info) {
  return informationSolidCylindre(1.2,0.6,n*3,n,1,info)+
         informationSolidCylindre(0.6,0.3,n*3,n,1,info);
}

static int informationScene3(typeInfo info) {
  return informationSolidSphere(0.5,n,n,info)+
         12*informationSolidCylindre(0.9,0.2,n,n*2,info)+
         8*informationSolidCube(0.6,n,info);
}

static void afficherInformations() {
  int nbSommets;
  int nbFacettes;
  int nbFacettes3;
  int nbFacettes4;
  switch (scn) {
    case 0 :
      nbSommets = informationScene0(NOMBRE_VERTICES);
      nbFacettes = informationScene0(NOMBRE_TOTAL_FACETTES);
      nbFacettes3 = informationScene0(NOMBRE_FACETTES_TRIANGULAIRES);
      nbFacettes4 = informationScene0(NOMBRE_FACETTES_QUADRANGULAIRES);
      break;
    case 1 :
      nbSommets = informationScene1(NOMBRE_VERTICES);
      nbFacettes = informationScene1(NOMBRE_TOTAL_FACETTES);
      nbFacettes3 = informationScene1(NOMBRE_FACETTES_TRIANGULAIRES);
      nbFacettes4 = informationScene1(NOMBRE_FACETTES_QUADRANGULAIRES);
      break;
    case 2 :
      nbSommets = informationScene2(NOMBRE_VERTICES);
      nbFacettes = informationScene2(NOMBRE_TOTAL_FACETTES);
      nbFacettes3 = informationScene2(NOMBRE_FACETTES_TRIANGULAIRES);
      nbFacettes4 = informationScene2(NOMBRE_FACETTES_QUADRANGULAIRES);
      break;
    case 3 :
      nbSommets = informationScene3(NOMBRE_VERTICES);
      nbFacettes = informationScene3(NOMBRE_TOTAL_FACETTES);
      nbFacettes3 = informationScene3(NOMBRE_FACETTES_TRIANGULAIRES);
      nbFacettes4 = informationScene3(NOMBRE_FACETTES_QUADRANGULAIRES);
      break; }
  glColor3f(1.0F,1.0F,0.0F);
  char texte[256];
  sprintf(texte,"%d vertices %d facettes (%d de 3 sommets,%d de 4 sommets)",nbSommets,nbFacettes,nbFacettes3,nbFacettes4);
  bitmapOutput(-0.95F,-0.95F,1.9F,texte,GLUT_BITMAP_HELVETICA_10);
}
/* Fonction executee lors d'un rafraichissement */
/* de la fenetre de dessin                      */

static void display(void) {
  if ( culling )
    glEnable(GL_CULL_FACE);
    else
    glDisable(GL_CULL_FACE);
  glPolygonMode(GL_FRONT_AND_BACK,( polygonMode ) ? GL_FILL : GL_LINE);
  if ( normalize )
    glEnable(GL_NORMALIZE);
    else
    glDisable(GL_NORMALIZE);
  if ( fond ) 
    glClearColor(0.0F,0.0F,0.0F,1.0F);
    else
    glClearColor(0.8F,0.8F,0.8F,1.0F);
  glPolygonMode(GL_FRONT_AND_BACK,(polygonMode == 1) ? GL_FILL : GL_LINE);

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glPushMatrix();

  glRotatef(rx,1.0F,0.0F,0.0F);
  glRotatef(ry,0.0F,1.0F,0.0F);
  glRotatef(rz,0.0F,0.0F,1.0F);

  glScalef(0.6F,0.6F,0.6F);

  switch (scn) {
    case 0 :
      scene0();
      break;
    case 1 :
      scene1();
      break;
    case 2 :
      scene2();
      break;
    case 3 :
      scene3();
      break; }

  glPopMatrix();

  afficherInformations();

  glFlush();
  glutSwapBuffers();
  int error = glGetError();
  if ( error != GL_NO_ERROR )
    printf("Attention erreur %d\n",error);
}

/* Fonction executee lors d'un changement       */
/* de la taille de la fenetre OpenGL            */

static void reshape(int wx,int wy) {
  wTx = wx; 
  wTy = wy; 
  glViewport(0,0,wx,wy); 
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  double ratio =(double) wx/wy; 
  if ( wx > wy ) 
    glOrtho(-ratio,ratio,-1.0,1.0,-2.0,2.0);
    else
    glOrtho(-1.0,1.0,-1.0/ratio,1.0/ratio,-2.0,2.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

/* Fonction executee lorsqu'aucun evenement     */
/* n'est en file d'attente                      */

static void idle(void) {
  /*static int num = 0; 
  static int depart = glutGet(GLUT_ELAPSED_TIME);
  int instantT = glutGet(GLUT_ELAPSED_TIME);
  num++;
  printf("%6d %6d %8.2lf\n",instantT,num,(double) num/instantT*1000.0);*/
  rx += sens;
  ry += sens;
  rz += sens;
  glutPostRedisplay();
}

/* Fonction executee lors de l'appui            */
/* d'une touche alphanumerique du clavier       */

static void keyboard(unsigned char key,int x,int y) {
  switch (key) {
    case 'n' :
      n--;
      if ( n < 1 )
        n = 1;
      glutPostRedisplay();
      break;
    case 'N' :
      n++;
      glutPostRedisplay();
      break;
    case 's' :
    case 'S' :
      { scn = (scn+1)%4;
        glutPostRedisplay(); }
      break;
    case 'f' :
      fond = !fond;
      glutPostRedisplay();
      break;
    case 0x0D :
      { anim = !anim;
        glutIdleFunc(( anim ) ? idle : NULL); }
      break;
    case 'c' :
      culling = !culling;
      glutPostRedisplay();
      break;
    case 'm' :
      polygonMode = !polygonMode;
      glutPostRedisplay();
      break;
    case 0x20 :
      normalize = !normalize;
      glutPostRedisplay();
      break;
    case 0x1B :
      exit(0);
      break; }
}

/* Fonction executee lors de l'appui            */
/* d'une touche speciale du clavier :           */
/*   - touches de curseur                       */
/*   - touches de fonction                      */

static void special(int specialKey,int x,int y) {
  switch(specialKey) {
    case GLUT_KEY_RIGHT :
      ry += 2.0F;
      glutPostRedisplay();
      break;
    case GLUT_KEY_LEFT :
      ry -= 2.0F;
      glutPostRedisplay();
      break; }
}

/* Fonction executee lors de l'utilisation      */
/* de la souris sur la fenetre                  */

static void mouse(int button,int state,int x,int y) {
  if ( ( button == GLUT_LEFT_BUTTON ) && ( state == GLUT_DOWN ) ) {
    mouseX = x;
    mouseActive = 1; }
  if ( ( button == GLUT_LEFT_BUTTON ) && ( state == GLUT_UP ) ) {
    mouseActive = 0; }
  if ( ( button == GLUT_RIGHT_BUTTON ) && ( state == GLUT_UP ) )
    sens *= -1.0F;
}

/* Fonction executee lors du passage            */
/* de la souris sur la fenetre                  */
/* avec un bouton presse                        */

static void mouseMotion(int x,int y) {
  if ( mouseActive ) {
    rz += (mouseX - x);
    mouseX = x;
    glutPostRedisplay(); }
}

/* Fonction executee lors du passage            */
/* de la souris sur la fenetre                  */
/* sans bouton presse                           */

static void passiveMouseMotion(int x,int y) {
}

/* Fonction exécutée automatiquement            */
/* lors de l'exécution de la fonction exit()    */

static void clean(void) {
  printf("Bye\n");
}

/* Fonction principale                          */

int main(int argc,char **argv) {

  atexit(clean);

  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_RGBA|GLUT_DEPTH|GLUT_DOUBLE);
  glutInitWindowSize(wTx,wTy);
  glutInitWindowPosition(wPx,wPy);
  glutCreateWindow("Materiaux et lumieres");
  init();
  glutKeyboardFunc(keyboard);
  glutSpecialFunc(special);
  glutMouseFunc(mouse);
  glutMotionFunc(mouseMotion);
  glutReshapeFunc(reshape);
  glutDisplayFunc(display);
  glutMainLoop();
  return(0);
}
